#include <stdio.h>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <iostream>
#include <sstream>
#include <algorithm>
#include <memory.h>
#include <cassert>
#include <string>

using namespace std;

#define pb push_back
#define mp make_pair
#define _(a, b) memset(a, b, sizeof(a))

typedef long long lint;
typedef unsigned long long ull;

const double eps = 1e-9;
const int INF = 1000000000;
const lint LINF = 4000000000000000000ll;

void prepare()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
}

struct vec2
{
	int x, y;
	vec2() { x = y = 0; }
	vec2(int x, int y): x(x), y(y) {}
};
bool operator < (const vec2 &a, const vec2 &b) { return a.y < b.y; }

const int findWidth = 50;
const int findDepth = 3;

const string botName = "t3h 1 g_release";

bool field[25][25][10];
bool used[25][25];
vec2 ballPosition;

int goalX;

vec2 path[15][25][25];
bool to[15][25][25];

const int fieldWidth = 20;
const int fieldHeight = 14;

void dfs(vec2 pos, int k, int goalX)
{
	for (int dx = -1; dx <= 1; dx++)
		for (int dy = -1; dy <= 1; dy++)
			if (dx != 0 || dy != 0)
			{
				int x = pos.x + dx;
				int y = pos.y + dy;
				if (x >= 0 && x <= fieldWidth && y >= 0 && y <= fieldHeight && !(x == 20 - goalX && y >= 6 && y <= 8))
				{
					bool ok = false;
					if (dx == 1 && dy == 0) ok = field[x - 1][y][0];
					else if (dx == -1 && dy == 0) ok = field[x][y][0];
					else if (dx == 0 && dy == 1) ok = field[x][y - 1][1];
					else if (dx == 0 && dy == -1) ok = field[x][y][1];
					else if (dx == 1 && dy == 1) ok = field[x - 1][y - 1][2];
					else if (dx == -1 && dy == -1) ok = field[x][y][2];
					else if (dx == 1 && dy == -1) ok = field[x - 1][y][3];
					else ok = field[x][y - 1][3];
					if (!ok)
					{
						if (!to[k][x][y])
						{
							to[k][x][y] = true;
							path[k][x][y] = pos;
							if (used[x][y])
								dfs(vec2(x, y), k, goalX);
						}
					}
				}
			}
}

void fillPath(vec2 start, vec2 pos, int k, bool fillValue)
{
	vector<vec2> answer;
	vec2 cur = pos;
	while (cur.x != start.x || cur.y != start.y)
	{
		answer.pb(cur);
		cur = path[k][cur.x][cur.y];
	}
	answer.pb(start);
	reverse(answer.begin(), answer.end());

	for (int i = 0; i < answer.size(); i++)
	{
		if (i != 0)
		{
			int x = answer[i].x;
			int y = answer[i].y;
			int dx = x - answer[i - 1].x;
			int dy = y - answer[i - 1].y;
			if (dx == 1 && dy == 0) field[x - 1][y][0] = fillValue;
			else if (dx == -1 && dy == 0) field[x][y][0] = fillValue;
			else if (dx == 0 && dy == 1) field[x][y - 1][1] = fillValue;
			else if (dx == 0 && dy == -1) field[x][y][1] = fillValue;
			else if (dx == 1 && dy == 1) field[x - 1][y - 1][2] = fillValue;
			else if (dx == -1 && dy == -1) field[x][y][2] = fillValue;
			else if (dx == 1 && dy == -1) field[x - 1][y][3] = fillValue;
			else field[x][y - 1][3] = fillValue;
		}
	}

	used[pos.x][pos.y] = fillValue;
}

//#include <queue>
//
//int dp[25][25];
//queue< vec2 > bfs;

int f(int x, int y, int k, int goalX)
{
	if (x == -1)
		return -INF;

	if (x == goalX && y >= 6 && y <= 8)
		return INF;
	else
	{
		/*_(dp, 127);
		for (int i = 0; i <= 20; i++)
			for (int j = 0; j <= 14; j++)
				if (to[k][i][j])
				{
					dp[i][j] = 1;
					bfs.push(vec2(i, j));
				}

		while (!bfs.empty())
		{
			vec2 pos = bfs.front();
			bfs.pop();

			int val = dp[pos.x][pos.y];

			for (int dx = -1; dx <= 1; dx++)
				for (int dy = -1; dy <= 1; dy++)
					if (dx != 0 || dy != 0)
					{
						int x = pos.x + dx;
						int y = pos.y + dy;
						if (x >= 0 && x <= fieldWidth && y >= 0 && y <= fieldHeight)
						{
							int nval = val + 1;
							if (dp[x][y] > nval)
							{
								dp[x][y] = nval;
								bfs.push(vec2(x, y));
							}
						}
					}
		}*/

		/*for (int j = 0; j <= 14; j++, printf("\n"))
			for (int i = 0; i <= 20; i++)
				printf("%3d", dp[i][j]);

		printf("\n");*/

		/*int ret = INF;
		for (int i = 6; i <= 8; i++)
			ret = min(ret, dp[goalX][i]);
		return ret;*/

		/*int r2;
		if (y <= 6)
			r2 = (x - goalX) * (x - goalX) + (y - 6) * (y - 6);
		else if (y == 7)
			r2 = (x - goalX) * (x - goalX);
		else
			r2 = (x - goalX) * (x - goalX) + (y - 8) * (y - 8);
		return -r2;*/

		if (abs(x - 20 + goalX) <= -1)
		{
			if (y <= 6)
				return max( abs(x - 20 + goalX), 6 - y );
			else if (y == 7)
				return abs(x - 20 + goalX);
			else
				return max( abs(x - 20 + goalX), y - 8 );
		}
		else
		{
			if (y <= 6)
				return -max( abs(x - goalX), 6 - y );
			else if (y == 7)
				return -abs(x - goalX);
			else
				return -max( abs(x - goalX), y - 8 );
		}
	}
}

vec2 findTurn(vec2 start, int k, int goalX)
{
	_(to[k], 0);
	// to[k][start.x][start.y] = true;
	_(path[k], 0);

	dfs(start, k, goalX);

	int bestResult = -INF;
	vector< pair<int, vec2> > best;
	for (int i = 0; i <= fieldWidth; i++)
		for (int j = 0; j <= fieldHeight; j++)
			if (to[k][i][j] && !used[i][j])
			{
				int result = f(i, j, k, goalX);
				best.pb( mp(result, vec2(i, j)) );
			}

	sort(best.rbegin(), best.rend());

	best.resize(min((size_t)findWidth, best.size()));
	
	if (k == findDepth)
	{
		if (best.size() == 0)
			return vec2(-1, -1);
		return best[0].second;
	}

	vector<vec2> result;

	int opt = -1, optValue = INF + 1;
	for (int i = 0; i < best.size(); i++)
	{
		fillPath(start, best[i].second, k, true);

		vec2 bestEnemy = findTurn(best[i].second, k + 1, 20 - goalX);
		int value = f(bestEnemy.x, bestEnemy.y, k + 1, 20 - goalX);
		if (optValue > value)
		{
			optValue = value;
			opt = i;
		}

		fillPath(start, best[i].second, k, false);
	}

	if (opt == -1)
		return vec2(-1, -1);

	return best[opt].second;
}

void makeTurn(int n)
{
	for (int i = 0; i < n; i++)
	{
		int x, y;
		scanf("%d%d", &y, &x);
		used[x][y] = true;
		if (ballPosition.x != x || ballPosition.y != y)
		{
			int dx = x - ballPosition.x;
			int dy = y - ballPosition.y;
			if (dx == 1 && dy == 0) field[x - 1][y][0] = true;
			else if (dx == -1 && dy == 0) field[x][y][0] = true;
			else if (dx == 0 && dy == 1) field[x][y - 1][1] = true;
			else if (dx == 0 && dy == -1) field[x][y][1] = true;
			else if (dx == 1 && dy == 1) field[x - 1][y - 1][2] = true;
			else if (dx == -1 && dy == -1) field[x][y][2] = true;
			else if (dx == 1 && dy == -1) field[x - 1][y][3] = true;
			else field[x][y - 1][3] = true;
		}
		ballPosition = vec2(x, y);
	}
	
	vector<vec2> answer;
	vec2 best = findTurn(ballPosition, 0, goalX);
	vec2 cur = best;
	while (cur.x != ballPosition.x || cur.y != ballPosition.y)
	{
		answer.pb(cur);
		cur = path[0][cur.x][cur.y];
	}
	answer.pb(ballPosition);
	reverse(answer.begin(), answer.end());

	printf("%d", answer.size());
	for (int i = 0; i < answer.size(); i++)
	{
		used[answer[i].x][answer[i].y] = true;

		if (i != 0)
		{
			int x = answer[i].x;
			int y = answer[i].y;
			int dx = x - answer[i - 1].x;
			int dy = y - answer[i - 1].y;
			if (dx == 1 && dy == 0) field[x - 1][y][0] = true;
			else if (dx == -1 && dy == 0) field[x][y][0] = true;
			else if (dx == 0 && dy == 1) field[x][y - 1][1] = true;
			else if (dx == 0 && dy == -1) field[x][y][1] = true;
			else if (dx == 1 && dy == 1) field[x - 1][y - 1][2] = true;
			else if (dx == -1 && dy == -1) field[x][y][2] = true;
			else if (dx == 1 && dy == -1) field[x - 1][y][3] = true;
			else field[x][y - 1][3] = true;
		}

		printf(" %d %d", answer[i].y, answer[i].x);
	}

	printf("\n");
	fflush(stdout);

	ballPosition = best;
}

char tmp[20];
bool process()
{
	scanf("%s", tmp);
	string cmd = string(tmp);
	
	if (cmd == "Name")
	{
		printf("%s w=%d d=%d\n", botName.c_str(), findWidth, findDepth);
		fflush(stdout);
	}
	else if (cmd == "Start")
	{
		goalX = 20;
		makeTurn(0);
	}
	else if (cmd == "Quit")
	{
		return false;
	}
	else
	{
		int n;
		sscanf(tmp, "%d", &n);
		makeTurn(n);
	}

	return true;
}

bool solve()
{
	goalX = 0;
	_(field, 0);
	_(used, 0);
	ballPosition = vec2(10, 7);
	used[10][7] = true;

	/*_(to, 0);
	_(path, 0);
	dfs(vec2(10, 7), 0, 20);
	f(10, 10, 0, 20);*/

	for (int i = 0; i <= fieldWidth; i++)
	{
		used[i][0] = used[i][fieldHeight] = true;
		field[i][0][0] = field[i][fieldHeight][0] = true;
	}

	for (int i = 0; i <= fieldHeight; i++)
	{
		used[0][i] = used[fieldWidth][i] = true;
		field[0][i][1] = field[fieldWidth][i][1] = true;
	}

	for (int i = 6; i <= 8; i++)
		used[0][i] = used[20][i] = false;

	while (process());

	return false;
}

int main()
{
	prepare();
	while (solve());
	return 0;
}