#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <iostream>

using namespace std;

const int bestCount = 3;

#define pb push_back
#define mp make_pair
#define For(i, a, b) for(int i = a; i < b; i++)
#define sz(a) ((int)a.size())

#define debug 0
#define cerr if(debug) cerr

const int lines = 14;
const int columns = 20;
const int goalLength = 4;
const int goalStart = ((lines - goalLength) / 2);
const int goalFinish = goalStart + goalLength;
int ourColumn;
bool moves[lines+1][columns+1][9];
int x, y;
int d[8][2]  = {{-1, -1}, {-1, 0}, {-1, 1}, {0, -1}, {0, 1}, {1, -1}, {1, 0}, {1, 1}};
int rd[8][2]  = {{0, 1}, {1, -1}, {1, 0}, {1, 1}, {-1, -1}, {-1, 0}, {-1, 1}, {0, -1}};

typedef vector<int> vi;
typedef vector<vi> vvi;

struct Point
{
	int x, y;

	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}

	bool operator ==(Point p)
	{
		return x == p.x && y == p.y;
	}
};

vector<Point> CollectMove(int x, int y, vector<vector<Point> > &parent) ;

vector<string> SplitByChar(string str, char separator)
{
	vector<string> res;
	int pos = 0;
	int len = 0;
	for (int i = 0; i < str.size(); i++)
	{
		if (str[i] == separator)
		{
			res.push_back(str.substr(pos, len));
			pos = i+1;
			len = 0;
		}
		else len++;
	}
	if (len != 0)
	{
		res.push_back(str.substr(pos, len));
	}
	return res;
}

int ParseInt(string str)
{
	int res = 0;
	for (int i = 0; i < str.size(); i++)
	{
		if (isdigit(str[i]))
			res = res*10 + (str[i] - '0');
	}
	return res;
}

vector<int> Split(string str)
{
	vector<string> args = SplitByChar(str, ' ');
	vector<int> res;
	for (int i = 0; i < args.size(); i++)
	{
		if (args[i].size() != 0)
			res.push_back(ParseInt(args[i]));
	}
	return res;
}


int MovesCount(int x, int y, vector<vector<vector<int> > > &moves)
{
	int res = 0;
	
	For(dir, 0, 8) {	
		int dx = d[dir][0];
		int dy = d[dir][1];
		int i = x + dx;
		int j = y + dy;
		if (i < 0 || i > lines || j < 0 || j > columns) continue;	
		if (moves[x][y][dir])
			res++;
	}
	return res;
}

int getDir(int dx, int dy) {
	for(int i = 0; i < 8; i++) {
		if(d[i][0] == dx && d[i][1] == dy) {
			return i;
		}
	}
	return 0;
}



void Fill(vector<Point> &v, vector<vector<vi> > &moves)
{
	for (int i = 1; i < v.size(); i++)
	{
//		moves[v[i].x][v[i].y][v[i - 1].x][v[i - 1].y] = true;
//		moves[v[i - 1].x][v[i - 1].y][v[i].x][v[i].y] = true;
		moves[v[i-1].x][v[i-1].y][getDir(v[i].x - v[i-1].x, v[i].y - v[i-1].y)] = true;
		moves[v[i].x][v[i].y][getDir(v[i-1].x - v[i].x, v[i-1].y - v[i].y)] = true;
	}
	x = v[v.size() - 1].x;
	y = v[v.size() - 1].y;
}

void Fill(vector<Point> &v)
{
	for (int i = 1; i < v.size(); i++)
	{
		moves[v[i-1].x][v[i-1].y][getDir(v[i].x - v[i-1].x, v[i].y - v[i-1].y)] = true;
		moves[v[i].x][v[i].y][getDir(v[i-1].x - v[i].x, v[i-1].y - v[i].y)] = true;

	}
	x = v[v.size() - 1].x;
	y = v[v.size() - 1].y;
}

void MakeEnemyMove(string str)
{
	vector<int> nums = Split(str);
	int moveLen = nums[0];
	vector<Point> points;
	for (int i = 0; i < moveLen; i++)
	{
		int x = nums[i * 2 + 1];
		int y = nums[i * 2 + 2];
		points.push_back(Point(x, y));
	}
	Fill(points);
}
/*
bool mark[lines+1][columns+1];
Point parent[lines+1][columns+1];

int resx, resy;
int resDistToMyGoal;
int resDistToCenter;
*/
/*
void InitDfs()
{
	memset(mark, 0, sizeof(mark));
	memset(parent, 0, sizeof(parent));
	vector<int> resx;
	vector<int> resy;
	vector<int> resDistToMyGoal;
	vector<int> resDistToCenter;
	For(i, 0, bestCount) {
		resx.pb(-1);
		resy.pb(-1);
		resDistToMyGoal.pb(;
		resDistToCenter.pb(
	}


//	resx = -1;
//	resy = -1;
//	resDistToMyGoal = -1;//columns + 2;
//	resDistToCenter = lines + 2;
}
*/

struct BfsRes {
	vector<vector<Point> > parent;
	int resx;
	int resy;
	int resDistToMyGoal;
	int resDistToCenter;
	BfsRes() {
		resx = resy = -1;
	}
};


const int inf = 0x7fffffff;

BfsRes bfs(Point start, vector<vector<vi> > &moves, bool isOurs, int depth) {
	cerr << "bfs " << depth << endl;
	vvi color;
	BfsRes res;
	res.parent.resize(lines + 1, vector<Point> (columns + 1));
	color.resize(lines + 1, vi(columns + 1));

	queue<Point> q;
	q.push(start);
	color[start.x][start.y] = 1;
	res.parent[start.x][start.y] = Point(-1, -1);
	res.resx = -1;
	res.resy = -1;
	res.resDistToMyGoal = -1;//columns + 2;	
	res.resDistToCenter = lines + 2;
	int opDistToMyGoal = inf;
	int opDistToCenter = lines + 2;
	


	while(sz(q)) {
		cerr << "sq(q) : " << sz(q) << endl;
		int curx = q.front().x;
		int cury = q.front().y;
		q.pop();

		for (int dir = 0; dir < 8; dir++)
		{
			cerr << "dir: " << dir << endl;
			int dx = d[dir][0];
			int dy = d[dir][1];
			int x = curx + dx;
			int y = cury + dy;
			if (x < 0 || x > lines || y < 0 || y > columns) continue;
			if(color[x][y]) {
				continue;
			}
			if (!moves[curx][cury][dir])
			{
				if (MovesCount(x, y, moves) == 0)
				{
					if(depth == 0) {
						res.parent[x][y] = Point(curx, cury);
						color[x][y] = true;
						int distToMyGoal = abs(y - ourColumn);
						if(isOurs == 0) {
							distToMyGoal = abs(y - (columns - ourColumn));
						}

						//if (distToMyGoal == 0) distToMyGoal = columns + 1;
						int distToCenter = abs(x - lines / 2);
						int flag = false;
						if (distToMyGoal > res.resDistToMyGoal) {
							flag = true;
						}
						else if (distToMyGoal == res.resDistToMyGoal) {
							if(distToMyGoal < 4) {
								if(distToCenter > res.resDistToCenter) {
									flag = true;
								}
							}
							else {	
								if(distToCenter < res.resDistToCenter) {
									flag = true;
								}
							}
						}
						
						if(flag) {
							res.resx = x;
							res.resy = y;
							res.resDistToMyGoal = distToMyGoal;
							res.resDistToCenter = distToCenter;
						}
					}
					else {
						color[x][y] = 1;
						res.parent[x][y] = Point(curx, cury);
						color[x][y] = true;
						
						vector<Point> myMove = CollectMove(x, y, res.parent);
						vector<vector<vi > > nMoves = moves;
						cerr << "depth before fill " << endl;
						Fill(myMove, nMoves);
						
						cerr << "depth before bfs " << endl;
						BfsRes localRes = bfs(Point(x, y), nMoves, !isOurs, depth - 1);
						
						cerr << "depth after bfs " << endl;
						int flag = false;
						localRes.resDistToMyGoal = columns - localRes.resDistToMyGoal;
						localRes.resDistToCenter = lines / 2 - localRes.resDistToCenter;
						if (localRes.resDistToMyGoal > res.resDistToMyGoal) {
							flag = true;
						}
						else if (localRes.resDistToMyGoal == res.resDistToMyGoal) {
							if(localRes.resDistToMyGoal < 4) {
								if(localRes.resDistToCenter > res.resDistToCenter) {
									flag = true;
								}
							}
							else {
							if(localRes.resDistToCenter < res.resDistToCenter) {
								flag = true;
							}
							}
						}
						
						if(flag) {
							res.resx = x;
							res.resy = y;
							res.resDistToMyGoal = localRes.resDistToMyGoal;
							res.resDistToCenter = localRes.resDistToCenter;
						}
					}
				}
				else
				{
					q.push(Point(x, y));
					color[x][y] = 1;
					res.parent[x][y] = Point(curx, cury);
				}
			}
		}
	}
	return res;
}
		
		/*


void Dfs(int curx, int cury, int lastx, int lasty)
{

	mark[curx][cury] = true;
	parent[curx][cury] = Point(lastx, lasty);
	for (int dir = 0; dir < 8; dir++)
	{
		int dx = d[dir][0];
		int dy = d[dir][1];
		int x = curx + dx;
		int y = cury + dy;
		if (x < 0 || x > lines || y < 0 || y > columns) continue;
		if (!moves[curx][cury][x][y] && !mark[x][y])
		{
			if (MovesCount(x, y) == 0)
			{
				parent[x][y] = Point(curx, cury);
				mark[x][y] = true;
				int distToMyGoal = abs(y - ourColumn);
				//if (distToMyGoal == 0) distToMyGoal = columns + 1;
				int distToCenter = abs(x - lines / 2);
				int flag = false;
				if (distToMyGoal > resDistToMyGoal) {
					flag = true;
				}
				else if (distToMyGoal == resDistToMyGoal) {
					if(distToMyGoal < 10) {
						if(distToCenter > resDistToCenter) {
							flag = true;
						}
					}
					else {
						if(distToCenter < resDistToCenter) {
							flag = true;
						}
					}
				}
				
				if(flag) {
					resx = x;
					resy = y;
					resDistToMyGoal = distToMyGoal;
					resDistToCenter = distToCenter;
				}
			}
			else
			{
				Dfs(x, y, curx, cury);
			}
		}
	}
}
*/
vector<Point> CollectMove(int x, int y, vector<vector<Point> > &parent) 
{
	vector<Point> res;
	while (!(x == -1 && y == -1))
	{
		Point p = Point(x, y);
		res.push_back(p);
		x = parent[p.x][p.y].x;
		y = parent[p.x][p.y].y;
	}
	reverse(res.begin(), res.end());
	return res;
}

void MakeMove()
{
//	InitDfs();
//	Dfs(x, y, -1, -1);
	vector<vector<vi> > lMoves(lines + 1, vector<vi>(columns + 1, vi(8)));
	For(x, 0, lines + 1) {
		For(y, 0, columns + 1) {
			For(dir, 0, 8) {	
				int dx = d[dir][0];
				int dy = d[dir][1];
				int i = x + dx;
				int j = y + dy;
				if (i < 0 || i > lines || j < 0 || j > columns) continue;	
				lMoves[x][y][dir] = moves[x][y][dir];
			}	
		}
	}
	BfsRes res = bfs(Point(x, y), lMoves, true, 1); 
	cerr << "beforeCollectMove" << endl;
	cerr << "resx" << res.resx << " resy" << res.resy << endl;

	vector<Point> myMove = CollectMove(res.resx, res.resy, res.parent);
	printf("%d", myMove.size());
	for (int i = 0; i < myMove.size(); i++)
		printf(" %d %d", myMove[i].x, myMove[i].y);
	printf("\n");
	cerr << "before FillMove" << endl;

	Fill(myMove);
	cerr << "after FillMove" << endl;

}

void FillEdge(int x1, int y1, int x2, int y2)
{
	if (x1 < 0 || x1 > lines) return;
	if (x2 < 0 || x2 > lines) return;
	if (y1 < 0 || y1 > columns) return;
	if (y2 < 0 || y2 > columns) return;
	moves[x1][y1][getDir(x2 - x1, y2 - y1)] = true;
}

void InitField(bool enemyFirst)
{
	x = lines / 2;
	y = columns / 2;
	ourColumn = enemyFirst ? columns : 0;

	for (int i = 0; i <= lines; i++)
	{
		if (i <= goalStart || i >= goalFinish)
		{
			FillEdge(i, 0, i - 1, 0);
			FillEdge(i, columns, i - 1, columns);
			FillEdge(i, 0, i + 1, 0);
			FillEdge(i, columns, i + 1, columns);
		}
	}
	for (int j = 0; j <= columns; j++)
	{
		FillEdge(0, j, 0, j - 1);
		FillEdge(0, j, 0, j + 1);
		FillEdge(lines, j, lines, j - 1);
		FillEdge(lines, j, lines, j + 1);
	}
}

char buf[1000];
void Run() {
	bool firstMove = true;
	while (true) {
		gets(buf);
		string str = string(buf);
		if (str == "Quit")
			return;
		if (str == "Name") {
			printf("Magtuv2\n");
			fflush(stdout);
			continue;
		}
		if (str != "Start") {
			if (firstMove) {
				InitField(true);
				firstMove = false;
			}
			MakeEnemyMove(str);
		}
		if (firstMove) {
			InitField(false);
			firstMove = false;
		}
		MakeMove();
		fflush(stdout);
	}
}

int main()
{
	
//	freopen("cerr.txt", "w", stderr);
	Run();
}