import java.io.*;
import java.util.*;

// 4/29/12 7:39 AM
// by Abrackadabra

public class Football {
    public static void main(String[] args) throws IOException {
        if (args.length > 0 && args[0].equals("Abra")) debugMode = true;
        new Football().run();
        /*new Thread(null, new Runnable() {
            public void run() {
                try {
                    new Test().run();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }, "1", 1 << 24).start();*/
    }

    int IOMode = 0; //0 - consoleIO, 1 - <taskName>.in/out, 2 - input.txt/output.txt, 3 - test case generator
    String taskName = "";

    void solve() throws IOException {
        String s = nextString();
        if (s.equals("Name")) out.println("____________");
        else System.exit(1);
        out.flush();
        Footballer footballer = null;
        boolean rotate = false;
        while (true) {
            s = nextString();
            if (s.equals("Quit")) return;
            if (!s.equals("Start")) {
                if (footballer == null) {
                    rotate = true;
                    footballer = new Footballer();
                }
                int n = Integer.parseInt(s);
                int[] x = new int[n];
                int[] y = new int[n];
                for (int i = 0; i < 2 * n; i++) {
                    if (i % 2 == 1) x[i / 2] = nextInt();
                    else y[i / 2] = nextInt();
                }
                if (rotate) {
                    for (int i = 0; i < n; i++) {
                        x[i] = 20 - x[i];
                    }
                }
                footballer.enemyTurn(n, x, y);
            } else {
                footballer = new Footballer();
            }
            ArrayList<Integer> turn = footballer.makeTurn();
            out.print(turn.size() / 2 + " ");
            for (int i = 0; i < turn.size(); i++) {
                if (i % 2 == 0) {
                    out.print(turn.get(i + 1) + " ");
                } else {
                    int x = turn.get(i - 1);
                    if (rotate) x = 20 - x;
                    out.print(x + " ");
                }
            }
            out.println();
            out.flush();
        }
    }

    long startTime = System.nanoTime(), tempTime = startTime, finishTime = startTime;
    long startMem = Runtime.getRuntime().totalMemory(), finishMem = startMem;

    void run() throws IOException {
        init();
        if (debugMode) {
            con.println("Start");
            con.println("Console:");
        }
        solve();
        finishTime = System.nanoTime();
        finishMem = Runtime.getRuntime().totalMemory();
        out.flush();
        if (debugMode) {
            int maxSymbols = 1000;
            BufferedReader tbr = new BufferedReader(new FileReader("input.txt"));
            char[] a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File input:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            tbr = new BufferedReader(new FileReader("output.txt"));
            a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File output:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            con.println("Execution time: " + (finishTime - startTime) / 1000000000.0 + " sec");
            con.println("Used memory:    " + (finishMem - startMem) + " bytes");
            con.println("Total memory:   " + Runtime.getRuntime().totalMemory() + " bytes");
        }
    }

    boolean tick(double x) {
        if (System.nanoTime() - tempTime > x * 1e9) {
            tempTime = System.nanoTime();
            con.println("Tick at " + (tempTime - startTime) / 1000000000 + " sec");
            con.print("   ");
            return true;
        }
        return false;
    }

    static boolean debugMode = false;
    PrintStream con = System.out;

    void init() throws IOException {
        if (debugMode && IOMode != 3) {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter(new FileWriter("output.txt"));
        } else
            switch (IOMode) {
                case 0:
                    br = new BufferedReader(new InputStreamReader(System.in));
                    out = new PrintWriter(System.out);
                    break;
                case 1:
                    br = new BufferedReader(new FileReader(taskName + ".in"));
                    out = new PrintWriter(new FileWriter(taskName + ".out"));
                    break;
                case 2:
                    br = new BufferedReader(new FileReader("input.txt"));
                    out = new PrintWriter(new FileWriter("output.txt"));
                    break;
                case 3:
                    out = new PrintWriter(new FileWriter("input.txt"));
                    break;
            }
        if (!debugMode)
            con = new PrintStream(new OutputStream() {
                public void write(int b) throws IOException {
                } // to /dev/null
            });
        if ((IOMode == 1 && taskName.length() == 0) || (IOMode != 1 && taskName.length() != 0)) {
            System.err.println("Leha, check IO settings");
            System.err.flush();
            System.exit(0);
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer in;

    boolean hasMoreTokens() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            String line = br.readLine();
            if (line == null) return false;
            in = new StringTokenizer(line);
        }
        return true;
    }

    String nextString() throws IOException {
        return hasMoreTokens() ? in.nextToken() : null;
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextString());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextString());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextString());
    }
}

class Footballer {
    final int width = 20, height = 14;
    int ballX = 10, ballY = 7;
    boolean[][][] usedEdges = new boolean[width + 1][height + 1][8];
    boolean[][] usedVertices = new boolean[width + 1][height + 1];
    long startTime = System.nanoTime();
    int[][] directions = {
            {0, -1},
            {1, -1},
            {1, 0},
            {1, 1},
            {0, 1},
            {-1, 1},
            {-1, 0},
            {-1, -1}
    };

    Footballer() {
        for (int i = 0; i <= width; i++) {
            usedEdges[i][0][0] = true;
            usedEdges[i][0][1] = true;
            usedEdges[i][0][2] = true;
            usedEdges[i][0][7] = true;
            usedEdges[i][0][6] = true;

            usedEdges[i][height][2] = true;
            usedEdges[i][height][3] = true;
            usedEdges[i][height][4] = true;
            usedEdges[i][height][5] = true;
            usedEdges[i][height][6] = true;

            usedVertices[i][0] = true;
            usedVertices[i][height] = true;
        }
        for (int i = 0; i <= height; i++) {
            usedEdges[0][i][0] = true;
            usedEdges[0][i][7] = true;
            usedEdges[0][i][6] = true;
            usedEdges[0][i][5] = true;
            usedEdges[0][i][4] = true;

            usedEdges[width][i][0] = true;
            usedEdges[width][i][1] = true;
            usedEdges[width][i][2] = true;
            usedEdges[width][i][3] = true;
            usedEdges[width][i][4] = true;

            usedVertices[0][i] = true;
            usedVertices[width][i] = true;
        }
    }

    int isInsideGates(int x, int y) {
        if (x == 0 && y < 9 && y > 5) return 1;
        if (x == width && y < 9 && y > 5) return 2;
        return 0;
    }

    void enemyTurn(int n, int[] x, int[] y) {
        ballX = x[0];
        ballY = y[0];
        usedVertices[ballX][ballY] = true;
        for (int i = 1; i < n; i++) {
            int nX = x[i], nY = y[i];
            usedVertices[nX][nY] = true;
            int q;
            for (q = 0; q < 8; q++) {
                int tX = ballX + directions[q][0];
                int tY = ballY + directions[q][1];
                if (tX == nX && tY == nY) break;
            }
            usedEdges[ballX][ballY][q] = true;
            usedEdges[ballX = nX][ballY = nY][(q + 4) % 8] = true;
        }
    }

    Stack<Integer> stack = new Stack<Integer>();
    HashSet<Integer> usedVerticesDFS = new HashSet<Integer>();
    HashSet<Integer> usedEdgesDFS = new HashSet<Integer>();
    int MOD = 30;
    int bestX = -1, bestY = -1;
    double best = -1;
    ArrayList<Integer> bestWay = new ArrayList<Integer>();
    Random random = new Random();
    int[][] resBFS = new int[width + 1][height + 1];

    void dfs(int x, int y) {
        if (System.nanoTime() - startTime >= 2e99) return;
        stack.add(x);
        stack.add(y);
        boolean canGo = false;
        boolean shouldGo = true;
        if (isInsideGates(x, y) == 1) {
            shouldGo = false;
        }
        if (isInsideGates(x, y) == 2) {
            bestX = 1000;
            bestX = 7;
            best = 1e99;
            bestWay.clear();
            for (int i : stack)
                bestWay.add(i);
            shouldGo = false;
        }
        if (!usedVertices[x][y] && !usedVerticesDFS.contains(x * MOD + y)) {
            shouldGo = false;
        }
        usedVerticesDFS.add(x * MOD + y);
        ArrayList<Integer> dirs = new ArrayList<Integer>();
        for (int i = 0; i < 8; i++)
            dirs.add(i);
        Collections.shuffle(dirs, random);
        for (int q = 0; q < 8 && shouldGo; q++) {
            int Q = dirs.get(q);
            if (usedEdges[x][y][Q] || usedEdgesDFS.contains(x * MOD * MOD + y * MOD + Q)) continue;
            canGo = true;
            int nx = x + directions[Q][0];
            int ny = y + directions[Q][1];
            usedEdgesDFS.add(x * MOD * MOD + y * MOD + Q);
            usedEdgesDFS.add(nx * MOD * MOD + ny * MOD + (Q + 4) % 8);
            dfs(nx, ny);
            usedEdgesDFS.remove(x * MOD * MOD + y * MOD + Q);
            usedEdgesDFS.remove(nx * MOD * MOD + ny * MOD + (Q + 4) % 8);
        }
        if (!canGo && !shouldGo) {
            if (howGood(x, y) > best) {
                bestX = x;
                bestY = y;
                best = howGood(x, y);
                bestWay.clear();
                for (int i : stack)
                    bestWay.add(i);
            }
        }
        usedVerticesDFS.remove(x * MOD + y);
        stack.pop();
        stack.pop();
    }

    boolean is_blocked(int x, int y) {

        for (int q = 0; q < 8; ++q) {
            if (usedEdges[x][y][q] || usedEdgesDFS.contains(x * MOD * MOD + y * MOD + q))
                continue;
            int nx = x + directions[q][0];
            int ny = y + directions[q][1];
            for (int qq = 0; qq < 8; ++qq) {

                if (usedEdges[nx][ny][qq] || usedEdgesDFS.contains(nx * MOD * MOD + ny * MOD + qq) || (qq == (q + 4) % 8)) {
                    continue;
                }
                return false;
            }
        }
        return true;
    }

    double howGood(int x, int y) {
        if (is_blocked(x, y)) {
            return 1e98;
        }
        if(x<=7)
            return x - (x <= 4 ? -1 : 1) * Math.abs(y - 7) / 3.0 + stack.size() / 1000.0;
        return x - (x <= 4 ? -1 : 1) * Math.abs(y - 7) / 3.0 + stack.size() / 1000.0 + 30.0 / resBFS[x][y];
    }

    void goBFS(){

        boolean[][] used = new boolean[width + 1][height + 1];

        ArrayList<Integer> cur = new ArrayList<Integer>();
        cur.add(20);
        cur.add(7);
        cur.add(20);
        cur.add(6);
        cur.add(20);
        cur.add(8);
        resBFS[20][7] = 0;
        used[20][7]  = true;

        resBFS[20][8] = 0;
        used[20][8]  = true;

        resBFS[20][6] = 0;
        used[20][6]  = true;
        while(!cur.isEmpty()){
            ArrayList<Integer> next = new ArrayList<Integer>();
            for(int i=0;i<cur.size()/2;++i){
                int X = cur.get(2 * i);
                int Y = cur.get(2 * i + 1);

                for(int q = 0 ;q< 8;++q){
                    if(usedEdges[X][Y][q])
                        continue;
                    int nx = X + directions[q][0];
                    int ny = Y + directions[q][1];
                    if(!used[nx][ny]){
                        next.add(nx);
                        next.add(ny);
                        resBFS[nx][ny] = resBFS[X][Y] + 1;
                        used[nx][ny] = true;
                    }
                }
            }
            cur = next;
        }
    }

    ArrayList<Integer> makeTurn() {

        startTime = System.nanoTime();

        int tx = ballX, ty = ballY;
        usedVertices[tx][ty] = true;

        goBFS();

        bestX = -1;
        bestY = -1;
        best = -1;
        bestWay = new ArrayList<Integer>();
        dfs(tx, ty);

        for (int i = 1; i < bestWay.size() / 2; i++) {
            int nX = bestWay.get(2 * i), nY = bestWay.get(2 * i + 1);
            usedVertices[nX][nY] = true;
            int q;
            for (q = 0; q < 8; q++) {
                int tX = ballX + directions[q][0];
                int tY = ballY + directions[q][1];
                if (tX == nX && tY == nY) break;
            }
            usedEdges[ballX][ballY][q] = true;
            usedEdges[ballX = nX][ballY = nY][(q + 4) % 8] = true;
        }
        return bestWay;
    }
}