#pragma comment(linker,"/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <map>
#include <set>
#include <ctime>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

#define WR printf
#define RE scanf
#define PB push_back
#define SE second
#define FI first
#define MP make_pair

#define FOR(i,k,n) for(int i=(k); i<=(n); i++)
#define DFOR(i,k,n) for(int i=(k); i>=(n); i--)
#define SZ(a) (int)((a).size())
#define FA(i,v) FOR(i,0,SZ(v)-1)
#define RFA(i,v) DFOR(i,SZ(v)-1,0)
#define CLR(a) memset(a, 0, sizeof(a))

#define LL long long
#define VI  vector<int>
#define PAR pair<int ,int>
#define o_O 1000000000



void __die(int a) {printf("%d",(a*a)/(a-37));}
void __never(int a){printf("\nOPS %d", a);}
#define ass(s) {if (!(s)) {__never(__LINE__);cout.flush();cerr.flush();__die(37);}}

#define SX 14
#define SY 20

#define GG1 5
#define GG2 9

#define MAX_DEEP 4

struct GAME
{
	bool was[SX+1][SY+1];
	bool F[SX+1][SY+1][3][3];
	int x, y;
	PAR pre[SX+1][SY+1];
	void init()
	{
		CLR(was);
		CLR(F);
		ass( SX%2==0 && SY%2==0 );
		x = SX/2;
		y = SY/2;
		was[x][y] = true;
	}
	int check_win()
	{
		if (GG1 < x && x < GG2)
		{
			if (y==0) return 2;
			if (y==SY) return 1;
		}
		return 0;
	}
	bool from_border(int x, int y)
	{
		if ((y==0 || y==SY) && (GG1 < x && x < GG2)) return false;
		return (x==0 || y==0 || x==SX || y==SY);
	}
	bool can_move(int xx, int yy)
	{
		return can_move(x,y,xx,yy);
	}
	bool can_move(int x1, int y1, int x2, int y2)
	{
		if (x1 < 0 || x1 > SX || y1 < 0 || y1 > SY) return false;
		if (x2 < 0 || x2 > SX || y2 < 0 || y2 > SY) return false;
		int dx = x2-x1, dy = y2-y1;
		if (dx==0 && dy==0) return false;
		if (abs(dx)>1) return false;
		if (abs(dy)>1) return false;
		if (F[x1][y1][dx+1][dy+1]) return false;
		if (F[x2][y2][1-dx][1-dy]) return false;
		//if (from_border(x1, y1) && from_border(x2, y2)) return false;
		bool f1 = (x1==0 || x1==SX || y1==0 || y1==SY);
		bool f2 = (x2==0 || x2==SX || y2==0 || y2==SY);
		if (f1 && f2) return false;

		return true;
	}
	void do_move( int xx, int yy )
	{
		ass( can_move(xx, yy) );
		int dx = xx-x, dy = yy-y;
		F[x][y][dx+1][dy+1] = true;
		x+=dx; y+=dy;
		F[x][y][1-dx][1-dy] = true;
		was[x][y] = true;
	}
	bool do_moves(vector< PAR > move)
	{
		ass(move[0] == MP(x, y));
		FA(a,move) if (a)
		{
			ass( can_move( move[a].FI, move[a].SE ) );
			ass( was[x][y] );

			int dx = move[a].FI-x, dy = move[a].SE-y;
			F[x][y][dx+1][dy+1] = true;
			x+=dx; y+=dy;
			F[x][y][1-dx][1-dy] = true;
			was[x][y] = true;
		}
		return true;
	}	
};

GAME field;
bool first = false;
int cost[SX+1][SY+1];
int cur_time;

void dfs( int x, int y, GAME & game )
{
	FOR(dx,-1,1) FOR(dy,-1,1) if (dx || dy)
		if (game.can_move(x, y, x+dx, y+dy))
			if (game.pre[x+dx][y+dy]==MP(0,0))
			{
				game.pre[x+dx][y+dy] = MP(x,y);
				if (!game.was[x+dx][y+dy] && !game.from_border(x+dx,y+dy))
					continue;
				//game.do_move(x+dx,y+dy);
				//game.F[x][y][dx+1][dy+1] = true;
				//game.F[x+dx][y+dy][1-dx][1-dy] = true;
				dfs(x+dx, y+dy, game);
				//game.F[x][y][dx+1][dy+1] = false;
				//game.F[x+dx][y+dy][1-dx][1-dy] = false;
			}
}

vector< PAR > get_moves( GAME & game )
{
	CLR(game.pre);

	game.pre[game.x][game.y] = MP(-1,-1);
	dfs(game.x, game.y, game);

	vector< PAR > re;
	FOR(a,0,SX) FOR(b,0,SY)
		if (game.pre[a][b]!=MP(0,0) && !game.was[a][b] && !game.from_border(a,b))
			re.PB( MP(a,b) );

	return re;
}

PAR g_path[10000];
int g_sz=0;

void make_path( GAME & g, PAR ans )
{
	g_sz = 0;

	while (1)
	{
		g_path[g_sz++] = ans;
		if (ans == MP(g.x, g.y)) break;
		ans = g.pre[ans.FI][ans.SE];
	}

	reverse( g_path, g_path+g_sz );
}

vector< PAR > get_path( GAME & g, PAR ans )
{
	vector< PAR > path;
	while (1)
	{
		path.PB( ans );
		if (ans == MP(g.x, g.y)) break;
		ans = g.pre[ans.FI][ans.SE];
	}

	reverse( path.begin(), path.end() );

	return path;
}

bool le( const PAR & A, const PAR & B )
{
	return A.SE < B.SE;
}

int dfs2( GAME & G, int pl, int deep )
{
	if (G.check_win()==1) return o_O;
	if (G.check_win()==2) return -o_O;
	if (deep==0) return G.y;

	vector< PAR > moves = get_moves( G );
	//random_shuffle( moves.begin(), moves.end() );
	sort( moves.begin(), moves.end(), le );
	if (pl==1) reverse( moves.begin(), moves.end() );

	int ans = (pl==1 ? -o_O : o_O);
	FA(a,moves)
	{
		GAME G2 = G;
		//vector< PAR > path = get_path( G, moves[a] );
		make_path( G, moves[a] );
		FOR(b,1,g_sz-1) G2.do_move( g_path[b].FI, g_path[b].SE );
		//G2.do_moves( path );
		int re = dfs2( G2, pl==1 ? 2 : 1, deep-1 );
		if (pl==1) ans = max( re, ans );
		else ans = min( re, ans );

		if (deep==MAX_DEEP) cost[moves[a].FI][moves[a].SE] = re;

		if (clock() - cur_time > 0.09*CLOCKS_PER_SEC) break;
	}

	return ans;
}

void make_move()
{
	bool LOG = false;
	FILE * lg;
	if (LOG)
	{
		if (first) lg = fopen("log1.txt", "w+");
		else lg = fopen("log2.txt", "w+");
	}

	GAME game2 = field;
	vector< PAR > vec = get_moves( game2 );
	//PAR ans = vec[ rand()%SZ(vec) ];

	if (LOG)
	{
		fprintf(lg, "moves=%d ", SZ(vec));
		FA(a,vec) fprintf(lg, "(%d %d) ", vec[a].FI, vec[a].SE);
		fprintf(lg, "\n");
		fflush(lg);
	}

	PAR ans = vec[0];
	FA(a,vec)
		if (first)
		{
			if (vec[a].SE > ans.SE) ans = vec[a];
		}
		else
		{
			if (vec[a].SE < ans.SE) ans = vec[a];
		}

	vector< PAR > path;
	while (1)
	{
		path.PB( ans );
		if (ans == MP(field.x, field.y)) break;
		ans = game2.pre[ans.FI][ans.SE];
	}

	reverse( path.begin(), path.end() );
	field.do_moves( path );

	if (LOG)
	{
		fprintf(lg, "%d ", SZ(path));
		FA(a,path) fprintf(lg, "(%d %d) ", path[a].FI, path[a].SE);
		fprintf(lg, "\n");
		fflush(lg);
		fclose(lg);
	}

	WR("%d ", SZ(path));
	FA(a,path) WR("%d %d ", path[a].FI, path[a].SE);
	WR("\n");
}

void make_move_2()
{
	int ZZ = o_O*2;
	if (first) ZZ = -o_O*2;

	FOR(a,0,SX) FOR(b,0,SY) cost[a][b] = ZZ;

	cur_time = clock();
	int ans = dfs2( field, first ? 1 : 2, MAX_DEEP );

	FOR(a,0,SX) FOR(b,0,SY)
		if (cost[a][b] == ans)
		{
			vector< PAR > path = get_path( field, make_pair(a, b) );
			field.do_moves( path );

			WR("%d ", SZ(path));
			FA(c,path) WR("%d %d ", path[c].FI, path[c].SE);
			WR("\n");
			return;
		}
}

int main()
{
	char buf[10000];
	field.init();
	while(1)
	{
		gets(buf);
		if (buf[0]=='Q') return 0;
		else if (buf[0]=='N')
		{
			cout << "TurtleCommanderBot06\n";
		}
		else if (buf[0]=='S')
		{
			first = true;
			make_move_2();
		}
		else
		{
			stringstream ss;
			ss << buf;
			int n, x, y;
			ss >> n;
			vector< PAR > vec;
			FOR(a,1,n)
			{
				ss >> x >> y;
				vec.PB( MP(x,y) );
			}
			field.do_moves( vec );
			make_move_2();
		}
		fflush(stdout);
	}
	return 0;
}
